-- Do not edit.  Generated on Thu Oct 14 11:04:28 2021 by tgingold
-- With Cheby 1.5.dev0 and these options:
--  -i fip_urv_regs.cheby --gen-hdl fip_urv_regs.vhd


library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
use work.wishbone_pkg.all;

entity fip_urv_regs is
  port (
    rst_n_i              : in    std_logic;
    clk_i                : in    std_logic;
    wb_i                 : in    t_wishbone_slave_in;
    wb_o                 : out   t_wishbone_slave_out;

    -- PLC processor control
    -- Put the PLC processor on reset
    plc_ctrl_rstn_o      : out   std_logic;

    -- Status bits from NanoFIP
    fip_status_var1_rdy_i : in    std_logic;
    fip_status_var3_rdy_i : in    std_logic;

    -- Set access to var 1
    fip_var1_acc_o       : out   std_logic;

    -- Set access to var 1
    fip_var3_acc_o       : out   std_logic;

    -- Mailbox to the fip urv
    mailboxes_mboxout_o  : out   std_logic_vector(31 downto 0);
    mailboxes_mboxout_wr_o : out   std_logic;

    -- Mailbox from the fip urv
    mailboxes_mboxin_i   : in    std_logic_vector(31 downto 0);
    mailboxes_mboxin_rd_o : out   std_logic;

    -- Status for mailboxes
    mailboxes_status_mbin_i : in    std_logic;
    mailboxes_status_mbout_i : in    std_logic;

    -- servmod lines for boards
    servmod_line_i       : in    std_logic_vector(7 downto 0);

    -- Servmod control lines
    servmod_ctrl_dir_o   : out   std_logic;

    -- Status lines for PSU
    psu_stat_pres_i      : in    std_logic_vector(1 downto 0);

    -- Control lines for PSU
    psu_ctrl_pwr_cyc_req_o : out   std_logic_vector(1 downto 0);

    -- led
    leds_val_o           : out   std_logic_vector(3 downto 0);

    -- Restart the fip urv (write 0x8e51a610)
    restart_o            : out   std_logic_vector(31 downto 0);
    restart_wr_o         : out   std_logic;

    -- REG pins
    boards_0_pins_i      : in    std_logic_vector(31 downto 0);

    -- REG pins
    boards_1_pins_i      : in    std_logic_vector(31 downto 0);

    -- REG pins
    boards_2_pins_i      : in    std_logic_vector(31 downto 0);

    -- REG pins
    boards_3_pins_i      : in    std_logic_vector(31 downto 0);

    -- REG pins
    boards_4_pins_i      : in    std_logic_vector(31 downto 0);

    -- REG pins
    boards_5_pins_i      : in    std_logic_vector(31 downto 0);

    -- REG pins
    boards_6_pins_i      : in    std_logic_vector(31 downto 0);

    -- REG pins
    boards_7_pins_i      : in    std_logic_vector(31 downto 0);

    -- i2c interfaces for monitors
    i2c_i                : in    t_wishbone_master_in;
    i2c_o                : out   t_wishbone_master_out;

    -- flash
    spi_i                : in    t_wishbone_master_in;
    spi_o                : out   t_wishbone_master_out;

    -- NanoFIP internal memory/registers
    fip_reg_i            : in    t_wishbone_master_in;
    fip_reg_o            : out   t_wishbone_master_out;

    -- Memory of the PLC urv
    plc_mem_i            : in    t_wishbone_master_in;
    plc_mem_o            : out   t_wishbone_master_out
  );
end fip_urv_regs;

architecture syn of fip_urv_regs is
  signal adr_int                        : std_logic_vector(13 downto 2);
  signal rd_req_int                     : std_logic;
  signal wr_req_int                     : std_logic;
  signal rd_ack_int                     : std_logic;
  signal wr_ack_int                     : std_logic;
  signal wb_en                          : std_logic;
  signal ack_int                        : std_logic;
  signal wb_rip                         : std_logic;
  signal wb_wip                         : std_logic;
  signal plc_ctrl_rstn_reg              : std_logic;
  signal plc_ctrl_wreq                  : std_logic;
  signal plc_ctrl_wack                  : std_logic;
  signal fip_var1_acc_reg               : std_logic;
  signal fip_var1_wreq                  : std_logic;
  signal fip_var1_wack                  : std_logic;
  signal fip_var3_acc_reg               : std_logic;
  signal fip_var3_wreq                  : std_logic;
  signal fip_var3_wack                  : std_logic;
  signal mailboxes_mboxout_wreq         : std_logic;
  signal servmod_ctrl_dir_reg           : std_logic;
  signal servmod_ctrl_wreq              : std_logic;
  signal servmod_ctrl_wack              : std_logic;
  signal psu_ctrl_pwr_cyc_req_reg       : std_logic_vector(1 downto 0);
  signal psu_ctrl_wreq                  : std_logic;
  signal psu_ctrl_wack                  : std_logic;
  signal leds_val_reg                   : std_logic_vector(3 downto 0);
  signal leds_wreq                      : std_logic;
  signal leds_wack                      : std_logic;
  signal restart_wreq                   : std_logic;
  signal i2c_re                         : std_logic;
  signal i2c_we                         : std_logic;
  signal i2c_wt                         : std_logic;
  signal i2c_rt                         : std_logic;
  signal i2c_tr                         : std_logic;
  signal i2c_wack                       : std_logic;
  signal i2c_rack                       : std_logic;
  signal spi_re                         : std_logic;
  signal spi_we                         : std_logic;
  signal spi_wt                         : std_logic;
  signal spi_rt                         : std_logic;
  signal spi_tr                         : std_logic;
  signal spi_wack                       : std_logic;
  signal spi_rack                       : std_logic;
  signal fip_reg_re                     : std_logic;
  signal fip_reg_we                     : std_logic;
  signal fip_reg_wt                     : std_logic;
  signal fip_reg_rt                     : std_logic;
  signal fip_reg_tr                     : std_logic;
  signal fip_reg_wack                   : std_logic;
  signal fip_reg_rack                   : std_logic;
  signal plc_mem_re                     : std_logic;
  signal plc_mem_we                     : std_logic;
  signal plc_mem_wt                     : std_logic;
  signal plc_mem_rt                     : std_logic;
  signal plc_mem_tr                     : std_logic;
  signal plc_mem_wack                   : std_logic;
  signal plc_mem_rack                   : std_logic;
  signal rd_ack_d0                      : std_logic;
  signal rd_dat_d0                      : std_logic_vector(31 downto 0);
  signal wr_req_d0                      : std_logic;
  signal wr_adr_d0                      : std_logic_vector(13 downto 2);
  signal wr_dat_d0                      : std_logic_vector(31 downto 0);
  signal wr_sel_d0                      : std_logic_vector(3 downto 0);
begin

  -- WB decode signals
  adr_int <= wb_i.adr(13 downto 2);
  wb_en <= wb_i.cyc and wb_i.stb;

  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        wb_rip <= '0';
      else
        wb_rip <= (wb_rip or (wb_en and not wb_i.we)) and not rd_ack_int;
      end if;
    end if;
  end process;
  rd_req_int <= (wb_en and not wb_i.we) and not wb_rip;

  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        wb_wip <= '0';
      else
        wb_wip <= (wb_wip or (wb_en and wb_i.we)) and not wr_ack_int;
      end if;
    end if;
  end process;
  wr_req_int <= (wb_en and wb_i.we) and not wb_wip;

  ack_int <= rd_ack_int or wr_ack_int;
  wb_o.ack <= ack_int;
  wb_o.stall <= not ack_int and wb_en;
  wb_o.rty <= '0';
  wb_o.err <= '0';

  -- pipelining for wr-in+rd-out
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        rd_ack_int <= '0';
        wr_req_d0 <= '0';
      else
        rd_ack_int <= rd_ack_d0;
        wb_o.dat <= rd_dat_d0;
        wr_req_d0 <= wr_req_int;
        wr_adr_d0 <= adr_int;
        wr_dat_d0 <= wb_i.dat;
        wr_sel_d0 <= wb_i.sel;
      end if;
    end if;
  end process;

  -- Register plc_ctrl
  plc_ctrl_rstn_o <= plc_ctrl_rstn_reg;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        plc_ctrl_rstn_reg <= '0';
        plc_ctrl_wack <= '0';
      else
        if plc_ctrl_wreq = '1' then
          plc_ctrl_rstn_reg <= wr_dat_d0(0);
        end if;
        plc_ctrl_wack <= plc_ctrl_wreq;
      end if;
    end if;
  end process;

  -- Register fip_status

  -- Register fip_var1
  fip_var1_acc_o <= fip_var1_acc_reg;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        fip_var1_acc_reg <= '0';
        fip_var1_wack <= '0';
      else
        if fip_var1_wreq = '1' then
          fip_var1_acc_reg <= wr_dat_d0(0);
        end if;
        fip_var1_wack <= fip_var1_wreq;
      end if;
    end if;
  end process;

  -- Register fip_var3
  fip_var3_acc_o <= fip_var3_acc_reg;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        fip_var3_acc_reg <= '0';
        fip_var3_wack <= '0';
      else
        if fip_var3_wreq = '1' then
          fip_var3_acc_reg <= wr_dat_d0(0);
        end if;
        fip_var3_wack <= fip_var3_wreq;
      end if;
    end if;
  end process;

  -- Register mailboxes_mboxout
  mailboxes_mboxout_o <= wr_dat_d0;
  mailboxes_mboxout_wr_o <= mailboxes_mboxout_wreq;

  -- Register mailboxes_mboxin

  -- Register mailboxes_status

  -- Register servmod

  -- Register servmod_ctrl
  servmod_ctrl_dir_o <= servmod_ctrl_dir_reg;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        servmod_ctrl_dir_reg <= '1';
        servmod_ctrl_wack <= '0';
      else
        if servmod_ctrl_wreq = '1' then
          servmod_ctrl_dir_reg <= wr_dat_d0(0);
        end if;
        servmod_ctrl_wack <= servmod_ctrl_wreq;
      end if;
    end if;
  end process;

  -- Register psu_stat

  -- Register psu_ctrl
  psu_ctrl_pwr_cyc_req_o <= psu_ctrl_pwr_cyc_req_reg;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        psu_ctrl_pwr_cyc_req_reg <= "00";
        psu_ctrl_wack <= '0';
      else
        if psu_ctrl_wreq = '1' then
          psu_ctrl_pwr_cyc_req_reg <= wr_dat_d0(1 downto 0);
        end if;
        psu_ctrl_wack <= psu_ctrl_wreq;
      end if;
    end if;
  end process;

  -- Register leds
  leds_val_o <= leds_val_reg;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        leds_val_reg <= "0000";
        leds_wack <= '0';
      else
        if leds_wreq = '1' then
          leds_val_reg <= wr_dat_d0(3 downto 0);
        end if;
        leds_wack <= leds_wreq;
      end if;
    end if;
  end process;

  -- Register restart
  restart_o <= wr_dat_d0;
  restart_wr_o <= restart_wreq;

  -- Register boards_0_pins

  -- Register boards_1_pins

  -- Register boards_2_pins

  -- Register boards_3_pins

  -- Register boards_4_pins

  -- Register boards_5_pins

  -- Register boards_6_pins

  -- Register boards_7_pins

  -- Interface i2c
  i2c_tr <= i2c_wt or i2c_rt;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        i2c_rt <= '0';
        i2c_wt <= '0';
      else
        i2c_rt <= (i2c_rt or i2c_re) and not i2c_rack;
        i2c_wt <= (i2c_wt or i2c_we) and not i2c_wack;
      end if;
    end if;
  end process;
  i2c_o.cyc <= i2c_tr;
  i2c_o.stb <= i2c_tr;
  i2c_wack <= i2c_i.ack and i2c_wt;
  i2c_rack <= i2c_i.ack and i2c_rt;
  i2c_o.adr <= ((26 downto 0 => '0') & adr_int(4 downto 2)) & (1 downto 0 => '0');
  i2c_o.sel <= wr_sel_d0;
  i2c_o.we <= i2c_wt;
  i2c_o.dat <= wr_dat_d0;

  -- Interface spi
  spi_tr <= spi_wt or spi_rt;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        spi_rt <= '0';
        spi_wt <= '0';
      else
        spi_rt <= (spi_rt or spi_re) and not spi_rack;
        spi_wt <= (spi_wt or spi_we) and not spi_wack;
      end if;
    end if;
  end process;
  spi_o.cyc <= spi_tr;
  spi_o.stb <= spi_tr;
  spi_wack <= spi_i.ack and spi_wt;
  spi_rack <= spi_i.ack and spi_rt;
  spi_o.adr <= ((26 downto 0 => '0') & adr_int(4 downto 2)) & (1 downto 0 => '0');
  spi_o.sel <= wr_sel_d0;
  spi_o.we <= spi_wt;
  spi_o.dat <= wr_dat_d0;

  -- Interface fip_reg
  fip_reg_tr <= fip_reg_wt or fip_reg_rt;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        fip_reg_rt <= '0';
        fip_reg_wt <= '0';
      else
        fip_reg_rt <= (fip_reg_rt or fip_reg_re) and not fip_reg_rack;
        fip_reg_wt <= (fip_reg_wt or fip_reg_we) and not fip_reg_wack;
      end if;
    end if;
  end process;
  fip_reg_o.cyc <= fip_reg_tr;
  fip_reg_o.stb <= fip_reg_tr;
  fip_reg_wack <= fip_reg_i.ack and fip_reg_wt;
  fip_reg_rack <= fip_reg_i.ack and fip_reg_rt;
  fip_reg_o.adr <= ((20 downto 0 => '0') & adr_int(10 downto 2)) & (1 downto 0 => '0');
  fip_reg_o.sel <= wr_sel_d0;
  fip_reg_o.we <= fip_reg_wt;
  fip_reg_o.dat <= wr_dat_d0;

  -- Interface plc_mem
  plc_mem_tr <= plc_mem_wt or plc_mem_rt;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        plc_mem_rt <= '0';
        plc_mem_wt <= '0';
      else
        plc_mem_rt <= (plc_mem_rt or plc_mem_re) and not plc_mem_rack;
        plc_mem_wt <= (plc_mem_wt or plc_mem_we) and not plc_mem_wack;
      end if;
    end if;
  end process;
  plc_mem_o.cyc <= plc_mem_tr;
  plc_mem_o.stb <= plc_mem_tr;
  plc_mem_wack <= plc_mem_i.ack and plc_mem_wt;
  plc_mem_rack <= plc_mem_i.ack and plc_mem_rt;
  plc_mem_o.adr <= ((18 downto 0 => '0') & adr_int(12 downto 2)) & (1 downto 0 => '0');
  plc_mem_o.sel <= wr_sel_d0;
  plc_mem_o.we <= plc_mem_wt;
  plc_mem_o.dat <= wr_dat_d0;

  -- Process for write requests.
  process (wr_adr_d0, wr_req_d0, plc_ctrl_wack, fip_var1_wack, fip_var3_wack, servmod_ctrl_wack, psu_ctrl_wack, leds_wack, i2c_wack, spi_wack, fip_reg_wack, plc_mem_wack) begin
    plc_ctrl_wreq <= '0';
    fip_var1_wreq <= '0';
    fip_var3_wreq <= '0';
    mailboxes_mboxout_wreq <= '0';
    servmod_ctrl_wreq <= '0';
    psu_ctrl_wreq <= '0';
    leds_wreq <= '0';
    restart_wreq <= '0';
    i2c_we <= '0';
    spi_we <= '0';
    fip_reg_we <= '0';
    plc_mem_we <= '0';
    case wr_adr_d0(13 downto 13) is
    when "0" =>
      case wr_adr_d0(12 downto 11) is
      when "00" =>
        case wr_adr_d0(10 downto 5) is
        when "000000" =>
          case wr_adr_d0(4 downto 2) is
          when "000" =>
            -- Reg plc_ctrl
            plc_ctrl_wreq <= wr_req_d0;
            wr_ack_int <= plc_ctrl_wack;
          when "001" =>
            -- Reg fip_status
            wr_ack_int <= wr_req_d0;
          when "010" =>
            -- Reg fip_var1
            fip_var1_wreq <= wr_req_d0;
            wr_ack_int <= fip_var1_wack;
          when "011" =>
            -- Reg fip_var3
            fip_var3_wreq <= wr_req_d0;
            wr_ack_int <= fip_var3_wack;
          when "100" =>
            -- Reg mailboxes_mboxout
            mailboxes_mboxout_wreq <= wr_req_d0;
            wr_ack_int <= wr_req_d0;
          when "101" =>
            -- Reg mailboxes_mboxin
            wr_ack_int <= wr_req_d0;
          when "110" =>
            -- Reg mailboxes_status
            wr_ack_int <= wr_req_d0;
          when others =>
            wr_ack_int <= wr_req_d0;
          end case;
        when "000001" =>
          case wr_adr_d0(4 downto 2) is
          when "000" =>
            -- Reg servmod
            wr_ack_int <= wr_req_d0;
          when "001" =>
            -- Reg servmod_ctrl
            servmod_ctrl_wreq <= wr_req_d0;
            wr_ack_int <= servmod_ctrl_wack;
          when "010" =>
            -- Reg psu_stat
            wr_ack_int <= wr_req_d0;
          when "011" =>
            -- Reg psu_ctrl
            psu_ctrl_wreq <= wr_req_d0;
            wr_ack_int <= psu_ctrl_wack;
          when "100" =>
            -- Reg leds
            leds_wreq <= wr_req_d0;
            wr_ack_int <= leds_wack;
          when "101" =>
            -- Reg restart
            restart_wreq <= wr_req_d0;
            wr_ack_int <= wr_req_d0;
          when others =>
            wr_ack_int <= wr_req_d0;
          end case;
        when "000010" =>
          case wr_adr_d0(4 downto 2) is
          when "000" =>
            -- Reg boards_0_pins
            wr_ack_int <= wr_req_d0;
          when "001" =>
            -- Reg boards_1_pins
            wr_ack_int <= wr_req_d0;
          when "010" =>
            -- Reg boards_2_pins
            wr_ack_int <= wr_req_d0;
          when "011" =>
            -- Reg boards_3_pins
            wr_ack_int <= wr_req_d0;
          when "100" =>
            -- Reg boards_4_pins
            wr_ack_int <= wr_req_d0;
          when "101" =>
            -- Reg boards_5_pins
            wr_ack_int <= wr_req_d0;
          when "110" =>
            -- Reg boards_6_pins
            wr_ack_int <= wr_req_d0;
          when "111" =>
            -- Reg boards_7_pins
            wr_ack_int <= wr_req_d0;
          when others =>
            wr_ack_int <= wr_req_d0;
          end case;
        when "000011" =>
          -- Submap i2c
          i2c_we <= wr_req_d0;
          wr_ack_int <= i2c_wack;
        when "000100" =>
          -- Submap spi
          spi_we <= wr_req_d0;
          wr_ack_int <= spi_wack;
        when others =>
          wr_ack_int <= wr_req_d0;
        end case;
      when "01" =>
        -- Submap fip_reg
        fip_reg_we <= wr_req_d0;
        wr_ack_int <= fip_reg_wack;
      when others =>
        wr_ack_int <= wr_req_d0;
      end case;
    when "1" =>
      -- Submap plc_mem
      plc_mem_we <= wr_req_d0;
      wr_ack_int <= plc_mem_wack;
    when others =>
      wr_ack_int <= wr_req_d0;
    end case;
  end process;

  -- Process for read requests.
  process (adr_int, rd_req_int, plc_ctrl_rstn_reg, fip_status_var1_rdy_i, fip_status_var3_rdy_i, fip_var1_acc_reg, fip_var3_acc_reg, mailboxes_mboxin_i, mailboxes_status_mbin_i, mailboxes_status_mbout_i, servmod_line_i, servmod_ctrl_dir_reg, psu_stat_pres_i, psu_ctrl_pwr_cyc_req_reg, leds_val_reg, boards_0_pins_i, boards_1_pins_i, boards_2_pins_i, boards_3_pins_i, boards_4_pins_i, boards_5_pins_i, boards_6_pins_i, boards_7_pins_i, i2c_i.dat, i2c_rack, spi_i.dat, spi_rack, fip_reg_i.dat, fip_reg_rack, plc_mem_i.dat, plc_mem_rack) begin
    -- By default ack read requests
    rd_dat_d0 <= (others => 'X');
    mailboxes_mboxin_rd_o <= '0';
    i2c_re <= '0';
    spi_re <= '0';
    fip_reg_re <= '0';
    plc_mem_re <= '0';
    case adr_int(13 downto 13) is
    when "0" =>
      case adr_int(12 downto 11) is
      when "00" =>
        case adr_int(10 downto 5) is
        when "000000" =>
          case adr_int(4 downto 2) is
          when "000" =>
            -- Reg plc_ctrl
            rd_ack_d0 <= rd_req_int;
            rd_dat_d0(0) <= plc_ctrl_rstn_reg;
            rd_dat_d0(31 downto 1) <= (others => '0');
          when "001" =>
            -- Reg fip_status
            rd_ack_d0 <= rd_req_int;
            rd_dat_d0(0) <= fip_status_var1_rdy_i;
            rd_dat_d0(1) <= fip_status_var3_rdy_i;
            rd_dat_d0(31 downto 2) <= (others => '0');
          when "010" =>
            -- Reg fip_var1
            rd_ack_d0 <= rd_req_int;
            rd_dat_d0(0) <= fip_var1_acc_reg;
            rd_dat_d0(31 downto 1) <= (others => '0');
          when "011" =>
            -- Reg fip_var3
            rd_ack_d0 <= rd_req_int;
            rd_dat_d0(0) <= fip_var3_acc_reg;
            rd_dat_d0(31 downto 1) <= (others => '0');
          when "100" =>
            -- Reg mailboxes_mboxout
            rd_ack_d0 <= rd_req_int;
          when "101" =>
            -- Reg mailboxes_mboxin
            mailboxes_mboxin_rd_o <= rd_req_int;
            rd_ack_d0 <= rd_req_int;
            rd_dat_d0 <= mailboxes_mboxin_i;
          when "110" =>
            -- Reg mailboxes_status
            rd_ack_d0 <= rd_req_int;
            rd_dat_d0(0) <= mailboxes_status_mbin_i;
            rd_dat_d0(1) <= mailboxes_status_mbout_i;
            rd_dat_d0(31 downto 2) <= (others => '0');
          when others =>
            rd_ack_d0 <= rd_req_int;
          end case;
        when "000001" =>
          case adr_int(4 downto 2) is
          when "000" =>
            -- Reg servmod
            rd_ack_d0 <= rd_req_int;
            rd_dat_d0(7 downto 0) <= servmod_line_i;
            rd_dat_d0(31 downto 8) <= (others => '0');
          when "001" =>
            -- Reg servmod_ctrl
            rd_ack_d0 <= rd_req_int;
            rd_dat_d0(0) <= servmod_ctrl_dir_reg;
            rd_dat_d0(31 downto 1) <= (others => '0');
          when "010" =>
            -- Reg psu_stat
            rd_ack_d0 <= rd_req_int;
            rd_dat_d0(1 downto 0) <= psu_stat_pres_i;
            rd_dat_d0(31 downto 2) <= (others => '0');
          when "011" =>
            -- Reg psu_ctrl
            rd_ack_d0 <= rd_req_int;
            rd_dat_d0(1 downto 0) <= psu_ctrl_pwr_cyc_req_reg;
            rd_dat_d0(31 downto 2) <= (others => '0');
          when "100" =>
            -- Reg leds
            rd_ack_d0 <= rd_req_int;
            rd_dat_d0(3 downto 0) <= leds_val_reg;
            rd_dat_d0(31 downto 4) <= (others => '0');
          when "101" =>
            -- Reg restart
            rd_ack_d0 <= rd_req_int;
          when others =>
            rd_ack_d0 <= rd_req_int;
          end case;
        when "000010" =>
          case adr_int(4 downto 2) is
          when "000" =>
            -- Reg boards_0_pins
            rd_ack_d0 <= rd_req_int;
            rd_dat_d0 <= boards_0_pins_i;
          when "001" =>
            -- Reg boards_1_pins
            rd_ack_d0 <= rd_req_int;
            rd_dat_d0 <= boards_1_pins_i;
          when "010" =>
            -- Reg boards_2_pins
            rd_ack_d0 <= rd_req_int;
            rd_dat_d0 <= boards_2_pins_i;
          when "011" =>
            -- Reg boards_3_pins
            rd_ack_d0 <= rd_req_int;
            rd_dat_d0 <= boards_3_pins_i;
          when "100" =>
            -- Reg boards_4_pins
            rd_ack_d0 <= rd_req_int;
            rd_dat_d0 <= boards_4_pins_i;
          when "101" =>
            -- Reg boards_5_pins
            rd_ack_d0 <= rd_req_int;
            rd_dat_d0 <= boards_5_pins_i;
          when "110" =>
            -- Reg boards_6_pins
            rd_ack_d0 <= rd_req_int;
            rd_dat_d0 <= boards_6_pins_i;
          when "111" =>
            -- Reg boards_7_pins
            rd_ack_d0 <= rd_req_int;
            rd_dat_d0 <= boards_7_pins_i;
          when others =>
            rd_ack_d0 <= rd_req_int;
          end case;
        when "000011" =>
          -- Submap i2c
          i2c_re <= rd_req_int;
          rd_dat_d0 <= i2c_i.dat;
          rd_ack_d0 <= i2c_rack;
        when "000100" =>
          -- Submap spi
          spi_re <= rd_req_int;
          rd_dat_d0 <= spi_i.dat;
          rd_ack_d0 <= spi_rack;
        when others =>
          rd_ack_d0 <= rd_req_int;
        end case;
      when "01" =>
        -- Submap fip_reg
        fip_reg_re <= rd_req_int;
        rd_dat_d0 <= fip_reg_i.dat;
        rd_ack_d0 <= fip_reg_rack;
      when others =>
        rd_ack_d0 <= rd_req_int;
      end case;
    when "1" =>
      -- Submap plc_mem
      plc_mem_re <= rd_req_int;
      rd_dat_d0 <= plc_mem_i.dat;
      rd_ack_d0 <= plc_mem_rack;
    when others =>
      rd_ack_d0 <= rd_req_int;
    end case;
  end process;
end syn;
