#ifndef __CHEBY__PLC_URV_REGS__H__
#define __CHEBY__PLC_URV_REGS__H__

#include "mbox_regs.h"
#define PLC_URV_REGS_SIZE 73824 /* 0x12060 */

/* None */
#define PLC_URV_REGS_SRAM 0x10000UL
#define PLC_URV_REGS_SRAM_SIZE 4 /* 0x4 */

/* None */
#define PLC_URV_REGS_SRAM_VALUE 0x0UL

/* None */
#define PLC_URV_REGS_MAILBOXES 0x12000UL
#define PLC_URV_REGS_MAILBOXES_SIZE 16 /* 0x10 */

/* presence lines for boards */
#define PLC_URV_REGS_PRESENCE 0x12010UL
#define PLC_URV_REGS_PRESENCE_EN_MASK 0xffUL
#define PLC_URV_REGS_PRESENCE_EN_SHIFT 0

/* None */
#define PLC_URV_REGS_LOOPS 0x12020UL
#define PLC_URV_REGS_LOOPS_SIZE 4 /* 0x4 */

/* None */
#define PLC_URV_REGS_LOOPS_PINS 0x0UL

/* None */
#define PLC_URV_REGS_RELAYS 0x12040UL
#define PLC_URV_REGS_RELAYS_SIZE 4 /* 0x4 */

/* None */
#define PLC_URV_REGS_RELAYS_PINS 0x0UL

struct plc_urv_regs {

  /* padding to: 16384 words */
  uint32_t __padding_0[16384];
  /* [0x10000]: MEMORY (no description) */
  struct sram {
    /* [0x0]: REG (rw) (no description) */
    uint32_t value;
  } sram[2048];

  /* [0x12000]: SUBMAP (no description) */
  struct mbox_regs mailboxes;

  /* padding to: 18436 words */
  uint32_t __padding_1[1];

  /* [0x12010]: REG (ro) presence lines for boards */
  uint32_t presence;

  /* padding to: 18440 words */
  uint32_t __padding_2[3];

  /* [0x12020]: REPEAT (no description) */
  struct loops {
    /* [0x0]: REG (ro) (no description) */
    uint32_t pins;
  } loops[8];

  /* [0x12040]: REPEAT (no description) */
  struct relays {
    /* [0x0]: REG (rw) (no description) */
    uint32_t pins;
  } relays[8];
};

#endif /* __CHEBY__PLC_URV_REGS__H__ */
